Package: InTAD
Type: Package
Title: Search for correlation between epigenetic signals and gene
        expression in TADs
Version: 1.31.0
Author: Konstantin Okonechnikov, Serap Erkek, Lukas Chavez
Maintainer: Konstantin Okonechnikov <k.okonechnikov@gmail.com>
Description: The package is focused on the detection of correlation between expressed genes and selected epigenomic signals (i.e. enhancers obtained from ChIP-seq data) either within topologically associated domains (TADs) or between chromatin contact loop anchors. Various parameters can be controlled to investigate the influence of external factors and visualization plots are available for each analysis step.  
License: GPL (>=2)
LazyData: TRUE
Depends: R (>= 3.5), methods, S4Vectors, IRanges, GenomicRanges,
        MultiAssayExperiment, SummarizedExperiment,stats
Imports:
        BiocGenerics,Biobase,rtracklayer,parallel,graphics,mclust,qvalue,
        ggplot2,utils,ggpubr
biocViews: Epigenetics, Sequencing, ChIPSeq, RNASeq, HiC,
        GeneExpression,ImmunoOncology
VignetteBuilder: knitr
Suggests: testthat, BiocStyle, knitr, rmarkdown
RoxygenNote: 6.0.1
git_url: https://git.bioconductor.org/packages/InTAD
git_branch: devel
git_last_commit: c1355bb
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 23:09:19 UTC; biocbuild

## InTAD R package ##

The main target of the package is to detect correlation between gene expression obtained from RNA-seq and selected epigenomic signals i.e. enhancers from ChIP-seq either within topologically associated domains (TADs) or between anchors of chromatin contact loops. Coordinates of TADs/loops can be detected using HiC and other methods and should be provided as additional input.

The analysis within TADs starts from collecting signals and genes lying in the same TAD. Then the combined groups in a TAD are analyzed to detect correlations among them. 

Another analysis approach is focused on the usage of confident chromatin loops. It uses the loops between genomic locations as input and searches if one anchor of the loop is overlapping with gene TSS, while another with target signal peak.

Various analysis parameters can be further controlled. For example, the expression filters, correlation limits (positive,negative), methods (Pearson, Spearman), etc. Each step also provides specific visualization plots.

Package is avialable at BioConductor:
http://bioconductor.org/packages/release/bioc/html/InTAD.html 

For more details please refer to the main vignette and documentation.

#' Preparation for correlation analysis via loops
#'
#' This function combines signals and genes based on the usage
#' of loops obtained from HiC data analysis
#' @param object InTADSig object
#' @param loopsInitDf Data frame with loops. By default 6-column format
#' \emph{(chr1,start1,end1,chr2,start2,pos2)} is expected.
#' @param fragmentLength In case the input format is 4-column \emph{(chr1,middlePos1,
#' chr2, middlePos2)} fragment length should be provided to extend the
#' corresponding loci for loop start and end positions.
#' @param tssWidth The transcription start site width is used to control overlaps
#' with loop anchor. Default is 2000 base pairs.
#' @param extSize The loop endings can be extended upstream and downstream
#' with provided corresponding increase size in base pairs.
#' @return Updated InTADSig object containing genes connected to signals
#' via loops
#'
#' @details
#' The expected input is the loops data.frame applied to find
#' connections of signals to genes. This data.frame could be
#' in two formats: either \emph{(chr1,start1,end1,chr2,start2,end2)} or
#' \emph{(chr1,middlePos1,chr2,middlePos2)} with fragment size.
#'
#' @importMethodsFrom GenomicRanges intersect
#' @importFrom BiocGenerics start end
#' @importFrom S4Vectors queryHits subjectHits
#'
#' @export
#'
combineWithLoops <- function( object, loopsInitDf,
                              fragmentLength = 0,
                              tssWidth = 2000,
                              extSize = 0) {

    if (!is(object, "InTADSig"))
        stop("Object must be an InTADSig!")

    if (fragmentLength == 0) {
      message("NOTE: 6-column loops format is assumed.")
      if (ncol(loopsInitDf) < 6) {
        stop("Loops data.frame should have at leaset 6 columns!")
      }
      selLoopsDf <-loopsInitDf[,1:6]
    } else {
      message("NOTE: binSize is provded, 4-column loops format is assumed.")
      if (ncol(loopsInitDf) < 4) {
        stop("Loops data.frame should have at least 6 columns!")
      }
      selLoopsDf <- data.frame( chr1 = loopsInitDf[,1],
                                x1 = loopsInitDf[,2] - fragmentLength/2,
                                y1 = loopsInitDf[,2] + fragmentLength/2,
                                chr2 = loopsInitDf[,3],
                                x2 = loopsInitDf[,4] - fragmentLength/2,
                                y2 = loopsInitDf[,4] + fragmentLength/2)
    }
    # clear enhancers with no connection
    loops <- paste0("loop",1:nrow(selLoopsDf))
    rownames(selLoopsDf) <- loops
    object@loopsDf <- selLoopsDf

    # form regions
    regions1 <- GRanges(seqnames = selLoopsDf[,1],
                        ranges = IRanges(start = selLoopsDf[,2], end = selLoopsDf[,3]))
    regions2 <- GRanges(seqnames = selLoopsDf[,4],
                        ranges = IRanges(start = selLoopsDf[,5], end = selLoopsDf[,6]))

    if (extSize > 0) {
      regions1 <- shift(regions1, -extSize)
      regions1 <- resize(regions1, width(regions1) + extSize*2)
      regions2 <- shift(regions2, -extSize)
      regions2 <- resize(regions2, width(regions2) + extSize*2)
    }
    geneGR <- rowRanges(object@sigMAE[["exprs"]])
    sigGR <- rowRanges(object@sigMAE[["signals"]])

    tss <- GRanges( seqnames=as.character(seqnames(geneGR)),
                    IRanges(start=ifelse(as.character(strand(geneGR))=="+",
                                         start(geneGR),end(geneGR)), width=tssWidth,
                            names=values(geneGR)$gene_name),
                    strand=strand(geneGR), geneid=values(geneGR)$gene_id )
    tss <- shift(tss, -tssWidth/2)

    # overlaps with enhancers
    enhUpstream <- findOverlaps(regions1,sigGR)
    enhDownstream <- findOverlaps(regions2,sigGR)

    # overlap with genes
    genesUpstream <- findOverlaps(regions1,tss)
    genesDownstream <- findOverlaps(regions2,tss)

    enhUpDf <- data.frame(Loop=loops[queryHits(enhUpstream)],
                          Enhancer=as.character(sigGR[subjectHits(enhUpstream)]),
                          stringsAsFactors = F)
    genesDownDf <- data.frame(Loop=loops[queryHits(genesDownstream)],
                              GeneId=tss[subjectHits(genesDownstream)]$geneid,
                              GeneName=names(tss[subjectHits(genesDownstream)]),
                              stringsAsFactors = F)
    res1 <- merge(enhUpDf, genesDownDf, by = "Loop")


    enhDownDf <- data.frame(Loop=loops[queryHits(enhDownstream)],
                            Enhancer=as.character(sigGR[subjectHits(enhDownstream)]),
                            stringsAsFactors = F)
    genesUpDf <- data.frame(Loop=loops[queryHits(genesUpstream)],
                            GeneId=tss[subjectHits(genesUpstream)]$geneid,
                            GeneName=names(tss[subjectHits(genesUpstream)]),
                            stringsAsFactors = F)
    res2 <- merge(enhDownDf, genesUpDf, by = "Loop")

    combRes <- rbind(res1,res2)
    object@loopConnections <- split(combRes, 1:nrow(combRes))

    message(paste("Combined",sum(sapply(object@loopConnections, nrow)),
                    "signal-gene pairs with loops" ))
    return(object)

}


findLoopPairCorrelation <- function(inData, signalVals, countVals, corMethod) {

  countSel <- as.numeric( countVals[inData$GeneId,])
  if ( sum(countSel) == 0) {
    return(NULL)
  }
  sigSel = as.numeric(signalVals[inData$Enhancer,])
  cors <- suppressWarnings(cor.test( sigSel, countSel, method=corMethod))
  euDis = as.numeric(dist(rbind ( sigSel, countSel)))
  corDF <- data.frame(peak=inData$Enhancer,loop=inData$Loop,
                      gene=inData$GeneId, name=inData$GeneName,
                      cor=cors$estimate,
                      pvalue=cors$p.value,
                      eucDist= euDis,
                      stringsAsFactors =FALSE)
  return(corDF)
}


#' Function to perfrom correlation analysis via loops.
#'
#' This function combines genes and signals using obtained loop connections.
#' @param object InTADSig object with signals and genes combined via loops
#' @param method Correlation method: "pearson" (default), "kendall", "spearman"
#' @param adj.pval Perform p-value adjsutment and include q-values in result
#' @return A table with correlation values for signal-gene pairs including
#' correlation p-value and euclidian distance.
#' @importFrom stats na.omit cor.test dist
#' @import qvalue
#' @export
#'
findCorFromLoops <- function(object, method = "pearson", adj.pval = FALSE ) {

  if (!is(object, "InTADSig"))
    stop("Object must be an InTADSig!")

  if (length(object@loopConnections)  == 0)
    stop("No signals and genes are connected via loops!
         Use combineWithLoops()  function.")

  if ((length(object@loopConnections)  < 3) & (adj.pval)) {
    warning("Number of signal-genes connection is too small
         for adjustment of p-value. Option is skipped.")
    adj.pval = FALSE
  }

  combList <- object@loopConnections
  selLoopsDf <- object@loopsDf

  if (object@ncore > 1 && requireNamespace("parallel")) {
    message("Running in parallel...")
    allRes <- parallel::mclapply(combList, findLoopPairCorrelation,
                                 assay(object@sigMAE[["signals"]]),
                                 assay(object@sigMAE[["exprs"]]),
                                 method)
  } else {
    allRes <- lapply(combList, findLoopPairCorrelation,
                     assay(object@sigMAE[["signals"]]),
                     assay(object@sigMAE[["exprs"]]),
                     method
    )
  }

  allRes <- allRes[lengths(allRes) != 0]
  allCortab <- do.call(rbind, lapply(allRes, function(x) x))

  loopAnn <- selLoopsDf[ allCortab$loop,]
  allCortab$loopStart = paste0(loopAnn[,1],":",loopAnn[,2],"-",loopAnn[,3])
  allCortab$loopEnd = paste0(loopAnn[,4],":",loopAnn[,5],"-",loopAnn[,6])

  # re-order, discard IDs of loops
  allCortab <- allCortab[, c(1,8,9,3:7)]

  if (adj.pval) {
    qvals <- tryCatch({
      qvalue(allCortab$pvalue)
    }, error = function(e) {
      qvalue(allCortab$pvalue, pi0=1)
    })
    allCortab <- cbind(allCortab, qvals$qvalues)
    colnames(allCortab)[ncol(allCortab)] <- "qvalue"
  }


  return(allCortab)
}

## Correlation testing

context("test on correlation")

test_that("correlation computation is correct", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- combineInTAD(inTadSig, tadGR)
    cID <- "chr15:26372163-26398073" #E2
 

    corData <- findCorrelation(inTadSig)
    selCorData <- corData[corData$peakid == cID, ]

    expect_equal( nrow(selCorData) , 30 )

    expect_equal( selCorData[ selCorData$name == "GABRA5","cor" ] , 0.878531,tolerance=1e-6)

    # this gene should be in since  option closest is active
    expect_equal( selCorData[ selCorData$name == "GABRB3","cor" ] , 0.6304704, tolerance=1e-6)

})

test_that("correlation properties are working correctly", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- combineInTAD(inTadSig, tadGR)
    corData <- findCorrelation(inTadSig, method="spearman")
    cID <- "chr15:26372163-26398073" #E2
 
    selCorData <- corData[corData$peakid == cID, ]
    expect_equal( selCorData[ selCorData$name == "GABRA5","cor" ] , 0.8361538, tolerance=1e-6)

    corData <- findCorrelation(inTadSig, adj.pval = TRUE)
    expect_equal( ncol(corData) , 9)

    selCorData <- corData[corData$peakid == cID, ]

    expect_equal( selCorData[ selCorData$name == "GABRA5","qvalue" ] , 6.276324e-06, tolerance=1e-6)

    # novel option 18.11.2018
    expect_equal( selCorData[ selCorData$name == "GABRA5","eucDist" ] , 10.92154 , tolerance=1e-6)



})

test_that("combine intad options are working correctly", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- combineInTAD(inTadSig, tadGR, closestGene = FALSE)
    corData <- findCorrelation(inTadSig)
    cID <- "chr15:26372163-26398073" #E2
 
    selCorData <- corData[corData$peakid == cID, ]

    expect_equal( nrow(selCorData) , 13)

    expect_equal( selCorData[ selCorData$name == "GABRA5","cor" ] , 0.878531,tolerance=1e-6)

})

test_that("check intad selMaxTadOvlp option", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    # adjust enhancers to initial selection
    targ <- findOverlaps(enhSelGR, GRanges("chr15:26003055-26976587"))
    enhSelGR <- enhSelGR[queryHits(targ)]
    enhSel <- enhSel[as.character(enhSelGR),]

    # novel enhnacer overlapping 2 tads
    # std tad chr15:25728907-27128907, close tad chr15:23608559-25368907
    novEnh <- "chr15:25367907-25738907"
    enhSel2 <- rbind(enhSel, c(rep(1, 20),rep(2,5)))
    rownames(enhSel2)[66] <-  novEnh
    enhSelGR2 <- c(enhSelGR,GRanges(novEnh))

    inTadSig <- newSigInTAD(enhSel2, enhSelGR2, rpkmCountsSel, txsSel)

    inTadSig <- filterGeneExpr(inTadSig, checkExprDistr = TRUE)

    # combine genes and signals in TAD: default largest overlap
    inTadSig <- combineInTAD(inTadSig, tadGR)
    expect_equal( length(inTadSig@signalConnections[[novEnh]]$tad) , 8)

    # combine enh with both TADs
    inTadSig <- combineInTAD(inTadSig, tadGR,selMaxTadOvlp = FALSE)
    expect_equal( length(inTadSig@signalConnections[[novEnh]]$tad) , 68)


})



test_that("check intad effect of no enhancers and TADs", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    # edit enhancers to remove overlap with TADs
    enhSelGR2 <- enhSelGR[1:2]
    start(enhSelGR2) <- c(3000,5000)
    end(enhSelGR2) <- c(4000,6000)

    inTadSig <- newSigInTAD(enhSel[1:2,], enhSelGR2, rpkmCountsSel, txsSel)

    expect_that(combineInTAD(inTadSig, tadGR),
                throws_error("No overlaps found between signal regions and TADs!"))

})


test_that("test loops usage", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")
    

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- combineWithLoops(inTadSig,loopsDfSel)
    res <- findCorFromLoops(inTadSig,method = "spearman")

    expect_equal( nrow(res) , 1)
    expect_equal( res[ 1,"name" ] ,"GABRA5")
    expect_equal( res[ 1,"cor" ] , 0.6123077,tolerance=1e-6)

})

findGeneCorrelation <- function(x, signalVals, countVals, corMethod) {
    genes <- x$geneid
    pId <- as.character(unique(x$peakid))
    #print(pId)

    corDat <- list()
    for (i in seq_len(length(genes))) {
        if (! (as.character(genes[i]) %in% row.names(countVals))) {
            #print(paste("NOT FOUND!", genes[i]))
            next
        }
        # log2 is taken into account in the generation of object
        countSel <- as.numeric( countVals[as.character(genes[i]), ])
        #print(as.character(genes[i]) )
        if ( sum(countSel) == 0) {
            next
        }
        sigSel = as.numeric(signalVals[pId,])
        cors <- suppressWarnings(cor.test( sigSel, countSel, method=corMethod))
        euDis = as.numeric(dist(rbind ( sigSel, countSel)))
        corDat[[i]] <- data.frame(gene=genes[i], eudis= euDis,
                                corr=cors$estimate,
                                pvalue=cors$p.value,
                                stringsAsFactors =FALSE)
    }
    corDF <- do.call(rbind, lapply(corDat, function(x) x))
    return(corDF)
}


#' Function to perfrom correlation analysis in TADs
#'
#' This function combines genes and signals in inside of TADs
#' @param object InTADSig object with signals and genes combined in TADS
#' @param method Correlation method: "pearson" (default), "kendall", "spearman"
#' @param adj.pval Perform p-value adjsutment and include q-values in result
#' @param plot.proportions Plot proportions of signals and genes in correlation
#' @return A table with correlation values for signal-gene pairs including
#' correlation p-value, euclidian distance and rank.
#' @importFrom stats na.omit cor.test dist
#' @import qvalue
#' @export
#' @examples
#' ## perform analysis on test data
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding")
#' inTadSig <- combineInTAD(inTadSig, tadGR)
#' corData <- findCorrelation(inTadSig, method="pearson")
#'

findCorrelation <- function(object, method = "pearson", adj.pval = FALSE,
                            plot.proportions = FALSE ) {

    if (!is(object, "InTADSig"))
        stop("Object must be an InTADSig!")

    if (length(object@signalConnections)  == 0)
        stop("No signals and genes are combined in TAD!
            Use combineInTAD() function.")

    sigCons <- object@signalConnections
    txs <- rowRanges(object@sigMAE[["exprs"]])

    if (sum(exprs(object)) == 0)
      stop("No genes expressed found : full expr. matrix sum equals zero!
           Check it via exprs() function for details.")

    # this null filtering was already performed in previous step
    allIdGnX <- sigCons[!sapply(sigCons, is.null)]
    allIdGnY <- allIdGnX[sapply(allIdGnX, function(x) dim(x)[1]) > 0]

    if (object@ncore > 1 && requireNamespace("parallel")) {
        message("Running in parallel...")
        allRes <- parallel::mclapply(allIdGnY, findGeneCorrelation,
                assay(object@sigMAE[["signals"]]),
                assay(object@sigMAE[["exprs"]]),
                method)
    } else {
        allRes <- lapply(allIdGnY, findGeneCorrelation,
                    assay(object@sigMAE[["signals"]]),
                    assay(object@sigMAE[["exprs"]]),
                    method)
    }

    allRes <- lapply(allRes, function(x) na.omit(x))

    allX <- list()
    for(i in seq_len(length(allRes))) {
        gnname <- values(txs)$gene_name[match(allRes[[i]]$gene,
                                            values(txs)$gene_id)]
        rnk <- allRes[[i]]$gene[order(allRes[[i]]$corr, decreasing=TRUE)]
        corRank <- match(allRes[[i]]$gene, rnk)
        #cluster <- cltab$cluster[match(names(allRes)[i], cltab$id)]
        peakName <- names(allRes)[i]
        tad <- unique(allIdGnX[[peakName]]$tad)
        #tad <- inTADpairs$tad[match(names(allRes)[i], inTADpairs$peakid)]
        allX[[i]] <- data.frame(peakid=rep(peakName, length(gnname)),
                            tad=rep(tad,length(gnname)),
                            gene=allRes[[i]]$gene, name=gnname,
                            cor=allRes[[i]]$corr,
                            pvalue=allRes[[i]]$pvalue,
                            eucDist = allRes[[i]]$eudis,
                            corRank=corRank,
                            stringsAsFactors =FALSE)
    }

    allCortab <- do.call(rbind, lapply(allX, function(x) x))

    if (adj.pval) {
        qvals <- tryCatch({
            qvalue(allCortab$pvalue)
        }, error = function(e) {
            qvalue(allCortab$pvalue, pi0=1)
        })
        allCortab <- cbind(allCortab, qvals$qvalues)
        colnames(allCortab)[9] <- "qvalue"
    }

    if (plot.proportions) {
        corDataF <- allCortab[allCortab$pvalue < 0.05,]
        if (nrow(corDataF) == 0) {
            warning("No conections detected")
            return(allCortab)
        }
        # plot 1
        assignedGeneProportion <- summary(as.factor(corDataF$gene),
                                            maxsum = nrow(corDataF))
        agpSorted <- sort(assignedGeneProportion, decreasing = TRUE)

        h <- hist( agpSorted, plot =FALSE )
        h$density = h$counts/sum(h$counts)*100
        plot(h, freq=FALSE, xlab="Number of signals",
            ylab = "Assigned genes (%)",
            col="blue",cex.main = 0.7,cex.axis=0.8,cex.lab=0.7,
            main = "Genes regulated by signals (p-val 0.05)")

        # plot 2
        assignedEnhProportion <- summary(as.factor(corDataF$peakid),
                                            maxsum = nrow(corDataF))
        aepSorted <- sort(assignedEnhProportion, decreasing = TRUE)

        h <- hist( aepSorted, plot =FALSE )
        h$density = h$counts/sum(h$counts)*100
        plot(h, freq=FALSE, xlab="Number of genes",
            ylab = "Assigned signals (%)",
            col="blue", cex.main = 0.7,cex.axis=0.8,cex.lab=0.7,
            main = "Signals regulating genes (p-val 0.05)")

    }

    return(allCortab)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----quick-start,  message=FALSE, warning=FALSE-------------------------------
library(InTAD)
# normalized enhancer signals table
enhSel[1:3,1:3]
# enhancer signal genomic coordinates 
as.data.frame(enhSelGR[1:3])
# gene expression normalized counts
rpkmCountsSel[1:3,1:3]
# gene coordiantes
as.data.frame(txsSel[1:3])
# additional sample info data.frame
head(mbAnnData)

## ----input-check1,  warning=FALSE---------------------------------------------
summary(colnames(rpkmCountsSel) == colnames(enhSel))

## ----input-check2,  warning=FALSE---------------------------------------------
# compare number of signal regions and in the input table
length(enhSelGR) == nrow(enhSel)

## ----test,  warning=FALSE-----------------------------------------------------
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel,mbAnnData)

## ----test2,  warning=FALSE----------------------------------------------------
inTadSig

## ----filter-genes,  warning=FALSE---------------------------------------------
# filter gene expression
inTadSig <- filterGeneExpr(inTadSig, checkExprDistr = TRUE)

## ----tad1,  warning=FALSE-----------------------------------------------------
# IMR90 hg19 TADs
head(tadGR)

## ----tad2,  warning=FALSE-----------------------------------------------------
# combine signals and genes in TADs
inTadSig <- combineInTAD(inTadSig, tadGR)

## ----cor,  warning=FALSE------------------------------------------------------
par(mfrow=c(1,2)) # option to combine plots in the graph
# perform correlation anlaysis
corData <- findCorrelation(inTadSig,plot.proportions = TRUE)

## ----cor2,  warning=FALSE-----------------------------------------------------
head(corData,5)

## ----loopsDf,  warning=FALSE--------------------------------------------------
loopsDfSel[1:4,1:6]

## ----loopsDf2,  warning=FALSE-------------------------------------------------
inTadSig <- combineWithLoops(inTadSig, loopsDfSel)

## ----loopsDf3,  warning=FALSE-------------------------------------------------
loopEag <- findCorFromLoops(inTadSig,method = "spearman")

## ----loopsDf4,  warning=FALSE-------------------------------------------------
loopEag

## ----plot0, warning=FALSE-----------------------------------------------------

# example enhancer in correlation with GABRA5
cID <- "chr15:26372163-26398073" 
selCorData <- corData[corData$peakid == cID, ]
selCorData[ selCorData$name == "GABRA5", ] 

## ----plot1,fig.align = "center", warning=FALSE--------------------------------

plotCorrelation(inTadSig, cID, "GABRA5",
                xLabel = "RPKM gene expr log2",
                yLabel = "H3K27ac enrichment log2", 
                colByPhenotype = "Subgroup")

## ----plot3, fig.align = "center", warning=FALSE-------------------------------
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 tads = tadGR)

## ----plot4, fig.align = "center", warning=FALSE-------------------------------
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 showCorVals = TRUE, tads = tadGR)

## ----plot5, fig.align = "center", warning=FALSE-------------------------------
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 showCorVals = TRUE, symmetric = TRUE, tads = tadGR)

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' Preparation for correlation analysis for a signal
#'
#' This function collects all genes for signal genomic region inside of
#' Topologically Associated Domains (TADs)
#' @param id Id of signal from the list
#' @param sigList List of signal GRs and their names
#' @param tadGR TAD genomic regions
#' @param tss Gene transcription start sites
#' @param pickMaxOvlp Use TAD with max overlap
#' @param nearestTad The table listing TADs nearest to each TSS
#'#'
#' @details
#' The signal is checked if it is lying inside of TAD.
#' Then all genes in this TAD are collected.
#'
#' @return Data.frame containing genes connected to signal
#'
fnSE <- function(id, sigList, tadGR, tss,  pickMaxOvlp, nearestTad) {

    sGR <- sigList[[id]]
    sName <- names(sigList)[id]
    #message(paste("Checking peak...", sName, sGR))
    ov1 <- findOverlaps(query=sGR, subject=tadGR)
    if (length(subjectHits(ov1)) == 0) {
        return(NULL)
    }

    if ( (length(subjectHits(ov1))>1) & pickMaxOvlp) {
        #message(paste("Overlapping:",sGR) )
        temp <- tadGR[subjectHits(ov1),]
        intsW <- NULL
        for(k in 1:length(temp)) {
            ints <- intersect(sGR,temp[k,])
            intsW[k] <- width(ints)
        }
        ovTad <- temp[which.max(intsW),]
    } else {
        ovTad <- tadGR[subjectHits(ov1),]
    }

    if (is.null(nearestTad)) {
        ovTss <- findOverlaps(query=tss, subject=ovTad, type="within")
        dattab <- data.frame(peakid=rep(sName,length(queryHits(ovTss))),
            geneid=values(tss)$geneid[queryHits(ovTss)],
            names=names(tss)[queryHits(ovTss)],
            tad=names(ovTad[subjectHits(ovTss)]),
            stringsAsFactors = FALSE)
    } else {

        closestGenes <- nearestTad[nearestTad$TAD %in% names(ovTad),,drop=FALSE]
        geneSel <- tss [ closestGenes$Gene ]

        dattab <- data.frame(peakid=rep(sName,nrow(closestGenes)),
            geneid=geneSel$geneid,names=names(geneSel),tad=closestGenes$TAD,
            stringsAsFactors = FALSE)

    }

    dattab2 <- unique(dattab)
    return(dattab2)
}

#' Preparation for correlation analysis
#'
#' This function combines signals and genes in inside of
#' Topologically Associated Domains (TADs)
#' @param object InTADSig object
#' @param tadGR TAD genomic regions
#' @param selMaxTadOvlp If a signal overlaps 2 or more TADs by default only
#' single TAD with max overlap is selected.All overlaps can be included by
#' deactivating this option.
#' @param closestGene By default closest to TAD genes are selected based
#' on TSS location. Deactivate this option to use genes only lying within TAD.
#'
#' @details
#' Each signal is checked if it is lying inside of TAD. Signals out of TADs
#' are ignored. The genomic regions reprenting gene coordiantes are converted
#' to TSS. By default, the closest genes are assigned belonging to TAD.
#' If this option deactivated, only those lying with TAD are collected.
#' Result is a list of signals connected to tables with gene details.
#'
#' @importMethodsFrom GenomicRanges intersect
#' @importFrom BiocGenerics start end
#' @importFrom S4Vectors queryHits subjectHits getListElement
#' @importFrom IRanges IRanges
#' @import graphics
#'
#' @return Updated InTADSig object containing genes connected to eash signal
#'
#' @export
#' @examples
#' # create sigInTAD object
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' # combine signals and genes in TAD
#' inTadSig <- combineInTAD(inTadSig, tadGR)
#'
#'
combineInTAD <- function( object, tadGR, selMaxTadOvlp = TRUE,
                            closestGene = TRUE) {

    if (!is(object, "InTADSig"))
        stop("Object must be an InTADSig!")

    # make sure TAD regions have names
    if (is.null(names(tadGR))) {
        names(tadGR) <- as.character(tadGR)
    }
    # coords requrired
    geneGR <- rowRanges(object@sigMAE[["exprs"]])
    sigGR <- rowRanges(object@sigMAE[["signals"]])

    if (sum(countOverlaps(sigGR,tadGR)) == 0) {
      stop("No overlaps found between signal regions and TADs!")
    }

    tss <- GRanges( seqnames=as.character(seqnames(geneGR)),
                IRanges(start=ifelse(as.character(strand(geneGR))=="+",
                start(geneGR),end(geneGR)), width=1,
                names=values(geneGR)$gene_name),
                strand=strand(geneGR), geneid=values(geneGR)$gene_id )

    nearestTad <- NULL
    if (closestGene) {
        nearestTss <- nearest(tss,tadGR)
        validTss <- !(is.na(nearestTss))
        nearestTad <- as.data.frame( cbind( names(tss)[validTss],
                                    names(tadGR[nearestTss[validTss]])),
                                    stringsAsFactors=FALSE )
        colnames(nearestTad) <- c("Gene", "TAD")
    }

    # fix issue with list
    sigList <- as( sigGR, "GRangesList")

    if (object@ncore > 1 && requireNamespace("parallel") ) {
        message("Running in parallel...")
        object@signalConnections <-
            parallel::mclapply( seq_along(sigList), fnSE,
                                sigList, tadGR, tss, selMaxTadOvlp,nearestTad )
    } else {
        object@signalConnections <-
            lapply( seq_along(sigList),fnSE,
                    sigList, tadGR, tss, selMaxTadOvlp, nearestTad)
    }
    names(object@signalConnections) <- names(object@sigMAE[["signals"]])

    # clear enhancers with no connection
    object@signalConnections <-
        object@signalConnections[!sapply(object@signalConnections, is.null)]
    message(paste("Combined",sum(sapply(object@signalConnections, nrow)),
                    "signal-gene pairs in TADs" ))
    return(object)

}

#' @name enhSel
#' @title Enhancer signals subset detected from medulloblatoma samples
#' @description This data.frame contains 65 selected in chr15  normalized
#' enhancers signals subset from 25 medulloblastoma samples.
#' @return NULL, but makes available the dataframe
#' @docType data
#' @usage enhSel
#' @format a data.frame instance
NULL

#' @name enhSelGR
#' @title Genomic coordiantes of enhancer signals subet
#' @description This GRanges object contains the coordinates of 65
#' medulloblastoma enhancer signals in chr15 target region
#' @return NULL, but makes available the dataset
#' @docType data
#' @usage enhSelGR
#' @format a GRanges object
NULL

#' @name rpkmCountsSel
#' @title Gene expression subset from medulloblastoma samples
#' @description This data.frame contains RPKM gene expression values from chr15
#' for subset from 25 medulluoblastoma samples.
#' @return NULL, but makes available the dataframe
#' @docType data
#' @usage rpkmCountsSel
#' @format a data.frame instance
NULL

#' @name txsSel
#' @title Genomic coordiantes of genes subset
#' @description This GRanges object contains the coordinates of genes
#' subset from chr15
#' @return NULL, but makes avaialbe the dataset
#' @docType data
#' @usage txsSel
#' @format a GRanges object
NULL

#' @name tadGR
#' @title Genomic coordiantes of topologically associated domains
#' @description This GRanges object contains the coordinates of TADs
#' revealed from IMR90 cell line (extracted from 0-indexed .bed file)
#' @return NULL, but makes available the dataset
#' @docType data
#' @usage tadGR
#' @format a GRanges object
NULL

#' @name mbAnnData
#' @title Data frame containing information about samples
#' @description The table includes additional informaiton about MB tumour
#' samples (subgroup, gender, age, histology and M.Stage)
#' @return NULL, but makes available the dataset
#' @docType data
#' @usage mbAnnData
#' @format a data.frame object
NULL

#' @name loopsDfSel
#' @title Data frame containing coordinates of loops
#' @description The table contains genomic coordinates of chromatin loops
#' in 6-column format derived from IMR90 cell line (focus : chr15)
#' @return NULL, but makes available the dataset
#' @docType data
#' @usage loopsDfSel
#' @format a data.frame object
NULL

# Classes

#' The InTADSig Class
#'
#' The InTADSig object stores signals and gene expression data for the samples.
#'
#' It uses MultiAssayExperiment object to store information. Key slots to access
#' are listed below.
#'
#'
#'@section Slots:
#'    \describe{
#'        \item{\code{sigMAE}:}{\code{"MultiAssayExperiment"},
#'        MultiAssayExperiment object containg signals and gene counts }
#'        \item{\code{signalConnections}:}{\code{"list"},
#'        The list of signals representing gene data frames in the same TAD }
#'        \item{\code{loopsDf}:}{\code{"data.frame"},
#'        The data.frame containing details of provided input loops }
#'        \item{\code{loopConnections}:}{\code{"list"},
#'        The list of connections between signals and genes via loops }
#'        \item{\code{ncore}:}{\code{"numeric"},
#'        Number of cores to use for parallel computing }#'
#'}
#' @name InTADSig
#' @rdname InTADSig
#' @aliases InTADSig-class
#' @exportClass InTADSig
#'
InTADSig <- setClass("InTADSig",
    slots = c(
        sigMAE = "MultiAssayExperiment",
        signalConnections = "list",
        loopsDf = "data.frame",
        loopConnections = "list",
        ncore = "numeric"
    )
)


################################################################################
### Validity check for InTADSig class object

setValidity("InTADSig", function(object) {

    msg <- NULL
    valid <- TRUE

    numSignalSamples <- ncol(signals(object))
    numExprSamples <- ncol(exprs(object))

    if ( (numSignalSamples != 0) && (numSignalSamples != numExprSamples) )  {
        valid <- FALSE
        msg <- c(msg, "Number of signal samples doesn't
                match number of RNA-seq samples")
    }

    if (  (length(rowRanges(object@sigMAE[["signals"]])) != 0) &&
        !identical(colnames(assay(object@sigMAE[["signals"]])),
                    colnames(assay(object@sigMAE[["signals"]]))) ) {
        valid <- FALSE
        msg <- c(msg, "Signal sample names must match RNA-seq sample names")
    }

    geneGR <- rowRanges(object@sigMAE[["exprs"]])

    if (!"gene_id" %in% colnames(values(geneGR)))
        stop("Annotation parameter \"gene_id\" is missing!")

    if (!"gene_name" %in% colnames(values(geneGR)))
        stop("Annotation parameter \"gene_name\" is missing!")

    numSameIds = sum(rownames(exprs(object)) == geneGR$gene_id )
    if ( numSameIds != length(geneGR))
        stop("The \"gene_id\" values in GRanges are not expr matrix row names!")

    if (valid) TRUE else msg
})


setMethod('show', signature='InTADSig', definition=function(object) {
    cat("S4 InTADSig object\n")
    signals <- signals(object)
    cat(paste("Num samples:", ncol(signals),"\n"))
    cat(paste("Num signals:", nrow(signals), "\n"))
    cat(paste("Num genes: ", nrow(exprs(object)), "\n"))
    #if (is.na(tads(object)))
    #    cat(paste("TAD regions are not set"))
    #else:
    #    cat(paste("TAD regions: ", length(tads(object), '\n'))
    }
)


#### Methods for extracting slots ###

#' @rdname signals
#' @export
setGeneric('signals', function(object) standardGeneric('signals'))

#' Signal values table
#'
#' This funcion returns the signal values table
#' @param object InTADSig object with signals and genes
#' @return Signals table
#' @rdname signals
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' head(signals(inTadSig))
#' @export
setMethod('signals', 'InTADSig',
            function(object) assay(object@sigMAE[["signals"]]))


#' @rdname sigCoords
#' @export
setGeneric('sigCoords',
            function(object) standardGeneric('sigCoords'))

#' Signal coords GRanges
#'
#' This funcion returns the signal GRanges
#' @param object InTADSig object with signals and genes
#' @return Signal GRanges
#' @rdname sigCoords
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' head(sigCoords(inTadSig))
#' @export
setMethod('sigCoords', 'InTADSig',
            function(object) rowRanges(object@sigMAE[["signals"]]))


#' Gene expression counts table
#'
#' This funcion returns gene expression counts table
#' @param object InTADSig object with signals and genes
#' @return Gene expression table
#' @rdname exprs
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' head(exprs(inTadSig))
#' @export
setMethod('exprs', signature='InTADSig',
          definition=function(object) assay(object@sigMAE[["exprs"]]))

# get pairs in TADs
setGeneric('sigLinks', function(object) standardGeneric('sigLinks'))
setMethod('sigLinks', 'InTADSig', function(object) object@signalConnections)

#' @rdname geneCoords
#' @export
setGeneric('geneCoords', function(object) standardGeneric('geneCoords'))

#' Gene coords GRanges
#'
#' This funcion returns the gene GRanges
#' @param object InTADSig object with signals and genes
#' @return Gene GRanges
#' @rdname geneCoords
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' head(geneCoords(inTadSig))
#' @export
setMethod('geneCoords', 'InTADSig',
            function(object) rowRanges(object@sigMAE[["exprs"]]))

### Methods for the InTADSig class

#' Create InTADSig object
#'
#' The fuction generates an object that contains the signals and gene expression
#' data.frames along with their genomic coordinates for further processing.
#'
#' @param signalData data frame containing signals
#' @param signalRegions genomic regions of the signals
#' @param countsData data matrix containing count expression values
#' @param geneRegions gene coordiantes
#' @param sampleInfo data frame containing additional sample info
#' @param performLog  Perform log2 convertion of expression values.
#' Default: TRUE.
#' @param logExprsOffset Offset x for log2 gene exrpression
#' i.e. log2(value + x). Default: 1
#' @param ncores Number of cores to use for parallel computing
#' @return Novel InTADSig object
#
#' @details
#' InTADSig object stores matrices of signals and gene expression values along
#' with coordinates. The order of samples and names of columns should match in both
#' datasets. For gene coordinates GRanges "gene_id" and "gene_name" are required
#' in metadata. These are typical markers of genes in GTF anntotation format.
#'
#' @import methods
#' @import SummarizedExperiment
#' @import MultiAssayExperiment
#' @importFrom S4Vectors DataFrame SimpleList
#' @export
#' @examples
#' ## create sigInTAD object
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#'
#'


newSigInTAD <- function(signalData = NULL,
                        signalRegions = NULL,
                        countsData = NULL,
                        geneRegions = NULL,
                        sampleInfo = NULL,
                        performLog = TRUE,
                        logExprsOffset = 1,
                        ncores = 1)
{
    ## Check that we have some expression data
    if ( is.null(signalData) || is.null(countsData))
        stop("Require signal and gene expression input data.frames.")

    if (!is(signalRegions, "GRanges"))
        stop("signalRegions must be GRanges object!")

    if (!is(geneRegions, "GRanges"))
        stop("geneRegions must be GRanges object!")

    if (is.null(sampleInfo)) {
        sampleInfo <- DataFrame(Type=paste0("Sample",seq_len(ncol(signalData))),
                                row.names=colnames(signalData))
    }

    # GRanges names should be ignored, only row names of tables are valid
    signalSE <- SummarizedExperiment(
        assays=SimpleList(counts=as.matrix(signalData, rownames.force=TRUE)),
        rowRanges=signalRegions, colData=sampleInfo)

    #names(rowRanges(signalSE)) <- rownames(assay(signalSE))
    exprSE <- SummarizedExperiment(
        assays=SimpleList(counts=as.matrix(countsData)),
        rowRanges=geneRegions, colData=sampleInfo)


    inTadMAE <- MultiAssayExperiment(list("signals"=signalSE,"exprs"=exprSE),
                                        sampleInfo)

    # Generate new object
    inTadSig <- new( "InTADSig", sigMAE = inTadMAE )



    # Check validity of object
    validObject(inTadSig)

    # Assign names for signal coords; is this required for MAE?
    # names(inTadSig@sigCoords) <- rownames(inTadSig@signals)

    # Log2 gene expression
    if (performLog) {
        assay(inTadSig@sigMAE[["exprs"]]) <-
            log2(assay(inTadSig@sigMAE[["exprs"]]) + logExprsOffset)
    }

    message(paste("Created signals and genes object for",
                    ncol(signalData) ,"samples"))
    inTadSig@ncore <- ncores
    if (ncores > 1) {
        pkgAvail <- requireNamespace("parallel")
        if (pkgAvail) {
            message(paste("Activate multicore computation. Num cores:",ncores))
            options(mc.cores=ncores)
        } else {
            stop("Package parallel is required for multi-core anlaysis!")
        }
    }

    inTadSig
}


#' Load InTADSig object from text files
#'
#' The fuction loads the data tables to create an object that contains the
#' signals and gene expression data.frames along with their genomic coordinates
#' for further processing.
#'
#' @param signalsFile Tab-seprated data table containg signals and their
#' coordinates as row.names
#' @param countsFile Tab-seprated counts table
#' @param gtfFile GTF file containing all gene coordinates
#' @param annFile Tab-delimited phenotype annotation of samples
#' @param performLog  Perform log2 convertion of expression values.
#' Default: TRUE.
#' @param logExprsOffset Offset x for log2 gene exrpression
#' i.e. log2(value + x). Default: 1
#' @param ncores Number of cores to use for parallel computing
#' @return Novel InTADSig object
#'
#' @importFrom rtracklayer import.gff
#' @importFrom utils read.delim
#' @import GenomicRanges
#'
#' @details
#' The function loads data from input files and creates object that stores
#' matrices of signals and gene expression values along with coordiantes.
#' The samples order and names of columns should match in both tables.
#' It is expected that gene ids are applied in the validation of counts table.
#'
#' @export
#' @examples
#' # create sigInTAD object
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#'
#'


loadSigInTAD <- function(signalsFile,
                        countsFile,
                        gtfFile,
                        annFile = "",
                        performLog = TRUE,
                        logExprsOffset = 1,
                        ncores = 1 )
{

    message("Loading signals...")
    sigtab <- read.delim(signalsFile)
    if (sum(colnames(sigtab)[seq_len(3)] ==   c("chr","start","end")) != 3)
        stop("First 3 columns of signal table should be genomic coordiantes
            with names \"chr\",\"start\",\"end\"!")

    sigCoords = sigtab[,c(1,2,3)]
    sigGR <- GRanges(sigCoords)
    sigData <- sigtab[, 4:ncol(sigtab)]

    ids <- paste(sigtab$chr,":", sigtab$start, "-", sigtab$end, sep="")
    rownames(sigData) <- ids

    message("Loading gene expression...")
    geneCounts <- read.delim(countsFile)

    message("Loading gene coordinates...")
    annData <- import.gff(gtfFile)
    if ("type" %in%  names(mcols(annData))) {
        message("Selecting only gene coordinates...")
        annData <- annData[annData$type == "gene",]
    }

    if (!"gene_id" %in% colnames(values(annData)))
        stop("Anntotation parameter \"gene_id\" is missing! Check GTF file.")

    # check order
    if (!"gene_id" %in% colnames(values(annData)))
        stop("Anntotation parameter \"gene_id\" is missing! Check GTF file.")

    numSameIds = sum(rownames(geneCounts) == annData$gene_id )
    if ( numSameIds != length(annData)) {
        message("Fixing row order of gene counts to correspond annotation...")
        geneCounts <- geneCounts[ annData$gene_id, ]

    }

    sInfo <- NULL
    if (nchar(annFile) > 0 ) {
        message("Loading annotation...")
        sInfo <- read.delim(annFile, header = TRUE,stringsAsFactors = FALSE)
    }

    # create object
    inTadSig <- newSigInTAD(sigData, sigGR, geneCounts, annData,
                            sampleInfo = sInfo,
                            performLog = performLog,
                            logExprsOffset = logExprsOffset,
                            ncores = ncores )

    inTadSig

}

## Initial testing

context("test on inputs")

test_that("signals and exprs input data are present", {
    expect_that(newSigInTAD(),
                throws_error("Require signal and gene expression input data.frames."))
})

test_that("genomic regions of signals are present", {
    data("mbSelEnhSignals")
    data("mbSamplesRPKM")
    
    expect_that(newSigInTAD(enhSel, list(), rpkmCountsSel, list()),
                throws_error("signalRegions must be GRanges object!"))
})


test_that("genomic regions of gene expresssion are present", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    
    expect_that(newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, list()),
                throws_error("geneRegions must be GRanges object!"))
})

# Control 
# Test: less region coords than regions
# Test: less gene coords than genes
# Test: less samples 

test_that("genomic regions have gene_id", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    txsSel$gene_id <- NULL
    expect_that(newSigInTAD(enhSel, enhSelGR, rpkmCountsSel,txsSel ),
                throws_error("Annotation parameter \"gene_id\" is missing!"))
})


test_that("genomic regions have gene_name", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    txsSel$gene_name <- NULL
    expect_that(newSigInTAD(enhSel, enhSelGR, rpkmCountsSel,txsSel ),
                throws_error("Annotation parameter \"gene_name\" is missing!"))
})

test_that("genomic regions correspond to gene counts row names", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    rpkmCounts2 <- rpkmCountsSel
    rownames(rpkmCounts2)[1] <- "BOO!"

    expect_that(newSigInTAD(enhSel, enhSelGR, rpkmCounts2,txsSel ),
                throws_error("The \"gene_id\" values in GRanges are not expr matrix row names!"))
})




test_that("test log2 gene expression", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    gID <- "ENSG00000186297.7"
    
    expect_equal( rpkmCountsSel[gID,24], 5.598033 , tolerance=1e-6)

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)

    normCounts <- assay(inTadSig@sigMAE[["exprs"]])

    # log2 normalization
    expect_equal( normCounts[gID, 24] , 2.722036,tolerance=1e-6)    



})

## Gene expression filtering

context("test filtering of gene expression")

test_that("genes with no expression are filtered", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")

    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)

    inTadSig <- filterGeneExpr(inTadSig)
    expect_equal( nrow(assay(inTadSig@sigMAE[["exprs"]])) , 1898 )

})

test_that("transcritpt type missing mark", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")
    
    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    
    expect_error( filterGeneExpr(inTadSig, geneType = "boo"),  
                    "The gene type \"boo\" is not found!" )

})

test_that("transcritpt type missing mark", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")
    
    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding") 

    expect_equal(  nrow(assay(inTadSig@sigMAE[["exprs"]])) , 612 )

})

# problematic test due to issue with mclust

test_that("transcritpt type missing mark", {
    data("mbSelEnhSignals")
    data("enhSelCoords")
    data("mbSamplesRPKM")
    data("txsSel")
    
    inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
    inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding", checkExprDistr  = TRUE) 

    # update 19.02 with gene_id: 
    # should be 429 by default for protein_coding only
    expect_equal(  nrow(assay(inTadSig@sigMAE[["exprs"]])) , 429 )

})

#' Function to plot correlation
#'
#' This function creates a plot of selected pair signal-gene
#' @param obj InTADSig object with signals and genes combined in TADS
#' @param sId Signal id based on genomic cooridantes i.e. "chr:start-end"
#' @param geneName Gene name to select. Based on "gene_name" attribute.
#' @param xLabel The label to mark signal X-axis. Default: "Gene expression"
#' @param yLabel The label to mark signal Y-axis. Default: "Signal enrichment"
#' @param colByPhenotype The pheno data column i.e. tumour type
#' that can be use for colour
#' @param corMethod Correlation method. Default: Pearson
#' @importFrom stats cor
#' @importFrom Biobase exprs
#' @import ggpubr
#' @import ggplot2
#' @return A \code{ggplot} object for visualization or customization.
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' inTadSig <- combineInTAD(inTadSig, tadGR)
#' plotCorrelation(inTadSig, "chr15:26372163-26398073", "GABRA5")
#'
#' @export
plotCorrelation <- function( obj, sId, geneName,
                            xLabel = "Gene expression",
                            yLabel = "Signal enrichment",
                            colByPhenotype = "",
                            corMethod = "pearson") {

    if (!is(obj, "InTADSig"))
        stop("Object must be an InTADSig!")

    # TODO: add option about TADs only as it was previously?

    if (nchar(colByPhenotype) > 0) {
        if (!( colByPhenotype %in% colnames(colData(obj@sigMAE))) )
            stop(paste0("Phenotype ", colByPhenotype," is not found!"))
    }

    if (!sId %in% rownames(signals(obj)) ) {
        stop("Signal is not found!")
    }

    ann <- geneCoords(obj)
    if (!geneName %in% ann$gene_name) {
      stop("Gene name not found!")
    }
    geneId <- ann[ann$gene_name == geneName]$gene_id

    message(geneId)
    toPlot<-data.frame(
        sig = signals(obj)[row.names(signals(obj))==sId, ],
        exp = exprs(obj)[row.names(exprs(obj))==geneId, ]
    )

    selColor <- "black"
    if (nchar(colByPhenotype) > 0) {
        toPlot <- cbind( toPlot, colData(obj@sigMAE)[, colByPhenotype] )
        colnames(toPlot)[3] <- colByPhenotype
        selColor <- colByPhenotype
    }

    title <- sprintf("%s - %s (cor = %.3f)",sId, geneName,
                    cor(toPlot$exp, toPlot$sig,method = corMethod))

    res <- ggscatter(toPlot, x="exp", y="sig",
                    color=selColor,
                    #palette = group.colors,
                    size = 4)+
        xlab(xLabel)+
        ylab(yLabel)+
        ggtitle(title)

    res

}



#' Function to plot correlation across genome
#'
#' This function creates a plot of correlation strength
#' in target genomic region from the result table.
#' The X-coordinates represent signals, Y-coords represent genes, while
#' each dot represents -log10(P-value) from correlation test.
#' Additionallly all TAD boundaries can be visualized.
#' @param obj InTADSig object with signals and genes combined in TADS
#' @param corRes Correlation result table created by function findCorrelation()
#' @param targetRegion Target genomic region visualise.
#' @param showCorVals Use this option to visualize postive correlation values
#' instead of correlation strength
#' @param symmetric Activate mirrow symmetry for gene-signal connections
#' @param tads TAD regions to visualize. By default only TADs persent in
#' correlation result table are applied (NULL value).
#'
#' @import ggplot2
#' @return A \code{ggplot} object for visualization or customization.
#' @examples
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' inTadSig <- combineInTAD(inTadSig, tadGR)
#' corData <- findCorrelation(inTadSig, method="pearson")
#' plotCorAcrossRef(inTadSig,corData,GRanges("chr15:25000000-28000000"))
#'
#' @export
plotCorAcrossRef <- function( obj, corRes, targetRegion,
                              showCorVals = FALSE, symmetric= FALSE,
                              tads = NULL) {

    if (!is(obj, "InTADSig"))
        stop("Object must be an InTADSig!")

    if (!is(targetRegion, "GRanges"))
        stop("Target region must be GRanges")

    if (sum( colnames(corRes)[seq_len(3)]  == c("peakid","tad","gene")) != 3)
        stop("Incorrect correlation table! Expected first 3 table
            column names: peakid, tad, gene")

    peaks <- GRanges(corRes$peakid)
    enhOverlap <- findOverlaps(sigCoords(obj), targetRegion)
    if (length(enhOverlap) == 0) {
        stop("No signals inside selected region detected.")
    }
    enhToCheck <- sigCoords(obj)[queryHits(enhOverlap)]

    # peaks within regions
    corSel <- corRes[ corRes$peakid %in% names(enhToCheck), ]
    genes <- geneCoords(obj)[unique(corRes$gene)]
    genesOverlap <- findOverlaps(genes, targetRegion,type = "within")
    genesToCheck <- genes[queryHits(genesOverlap)]
    # both peaks and genes within regions
    corSel2 <- corSel[ corSel$gene %in% genesToCheck$gene_id, ]

    sigSel <- GRanges(corSel2$peakid)
    geneSel <- genesToCheck[ corSel2$gene ]

    if (showCorVals) {
        res <- cbind(start(sigSel), end(sigSel),
                start(geneSel), end(geneSel),
                corSel2$cor)
    } else {
        res <- cbind(start(sigSel), end(sigSel),
                   start(geneSel), end(geneSel),
                   -log10(corSel2$pvalue + 1e-09))

    }

    # start position version
    dt <- as.data.frame(res[,c(1,3,5)])
    if (showCorVals) {
      dt <- dt[dt[,3] > 0, ]
    }

    xLab = "Signal coords (bp)"
    yLab = "Gene coords (bp)"

    if (symmetric) {
      xLab = "Genomic coords (bp)"
      yLab = "Genomic coords (bp)"
      t2 <- cbind(t(apply(dt[,1:2], 1, sort)),dt[,3])
      t3 <- t2[,c(2,1,3)]
      dt <- as.data.frame(rbind(t2,t3))
    }

    colnames(dt) <- c("enh","gene","cor")

    if (nrow(dt) == 0)
        stop("No correlation between signal and genes
            found inside selected region")

    if (showCorVals) {
        legendLab = "Cor"
    } else {
        legendLab = "-log10(P)"
    }

    sp <- ggplot( dt, aes_string(x="enh",y="gene",color="cor")) +
        geom_point() + labs(color=legendLab) +
        labs(title = paste("Region",as.character(targetRegion)),
            x = xLab, y= yLab) +
        theme(plot.title = element_text(hjust = 0.5)) +
        expand_limits( x=c(start(targetRegion), end(targetRegion)),
                    y=c(start(targetRegion), end(targetRegion))) +
        scale_color_gradient(low = "white", high = "red")

    # add TAD borders

    if (!is.null(tads)) {
        if (is(tads, "GRanges")) {
            selTadGR <- tads
        }
    } else {
        selTadGR <-  GRanges(unique(corRes$tad))
    }

    tadOverlap <- selTadGR[queryHits(findOverlaps(selTadGR, targetRegion))]
    yStartLim = min( c(min(start(tadOverlap)),start(targetRegion) ))
    yEndLim = max( c(max(end(tadOverlap)),end(targetRegion) ))

    if (length(tadOverlap) > 0) {
        sp <- sp + geom_rect(data = as.data.frame(tadOverlap),
                            inherit.aes = FALSE,
                            aes(xmin = start, xmax=end,ymin=start, ymax=end),
                            fill=NA, color="black", linetype=3) +
            coord_cartesian(ylim=c(start(targetRegion), end(targetRegion)),
                        xlim=c(start(targetRegion), end(targetRegion)))
    }

    diagDf <- as.data.frame(rbind( rep(start(targetRegion),2),
                                 rep(end(targetRegion),2) ))
    colnames(diagDf) <- c("start","end")
    sp <- sp + geom_line(data = diagDf,inherit.aes = FALSE,
                         aes(x=start,y=end), col="gray",linetype=8)

    sp <- sp + scale_y_reverse(lim=c(yEndLim, yStartLim))
    sp

}

#' Function to filter gene expression
#'
#' This function performs filtering of gene expression counts based on various
#'  parameters
#' @param obj InTADSig object
#' @param cutVal Exclude genes that have max expression less or equal to
#' this value in all samples. Default: 0
#' @param geneType Type of gene to select for filtering i.e. "protein_coding".
#' Default:NA
#' @param checkExprDistr Adjust cutVal based on gene expression distribution
#' @param plotExprDistr Perform visualziation of the distribution
#' @return InTADSig object with filtered counts table
#' @details
#' The function allows to stabilize the functional activity of the genes. By
#' default all not expressed genes are filtered. It is also possible to set type
#' of gene to take into account i.e. "protein_coding" only. This option requires
#' additional metadata column "transcript_type".
#' Also, special filtering option based on mclust library allows to analyze
#' distribution of counts and adjust the cut value to exclude low expressed
#' genes.
#' @importFrom stats qnorm dnorm density
#' @export
#' @examples
#' ## perform analysis on test data
#' inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
#' ## default filtering
#' inTadSig <- filterGeneExpr(inTadSig)
#' ## filter based on gene type
#' inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding")
#'
#'
filterGeneExpr <- function(obj, cutVal = 0, geneType = NA,
                        checkExprDistr = FALSE, plotExprDistr = FALSE ) {

    if (!is(obj, "InTADSig"))
        stop("Object must be an InTADSig!")

    if (length(obj@signalConnections)  != 0)
        warning("Signals and genes are already combined in TAD,
            rerun combineInTAD() function to update the result.")

    # TODO: create an object to keep initial gene expression

    RNA <- assay(obj@sigMAE[["exprs"]])
    txs <- rowRanges(obj@sigMAE[["exprs"]])

    message(paste("Initial result:", nrow(RNA), "genes"))

    if (checkExprDistr) {
        vals <- as.vector(RNA)
        # P value <--> log2 ratio
        # pval2ratio <- function(pval,  background)
        # {qnorm(pval,mean=background[1], sd=background[2], lower.tail=FALSE)}

        ### define positive/negative cut-off (by fitting normal mixture model)
        pcut <- 0.01

        d1 <- density(vals,na.rm=TRUE)
        bg1 <- get.enr.bg.normfit(vals)
        if (sum(is.na(bg1)) == 0) {
            #ratiocut <- pval2ratio(pcut, background=bg1)
            ratiocut <- qnorm(pcut,  mean=bg1[1], sd=bg1[2], lower.tail=FALSE)

            if (plotExprDistr) {
                bgProp1 = attr(bg1, "proportions")[1]
                bgProp2 = attr(bg1, "proportions")[2]
                plot(d1, col='gray', lwd=3, main="Normal Mixture Model",
                    ylim=c(0,2.5),xlab="Expression", ylab="Density")
                lines(x=d1$x,
                    y=dnorm(d1$x, mean=bg1[1], sd=bg1[2])*bgProp1,
                    lwd=3, col="blue")
                lines(x=d1$x,
                    y=dnorm(d1$x, mean=attr(bg1, "enr.mean"),
                    sd=attr(bg1, "enr.sd")) * bgProp2,
                    lwd=3, lty=2, col="green")
                abline(v=ratiocut, lwd=3, col="red")
                legend(x="topright", bty="n", lty=c(1,1,2,1,NA),
                    lwd=c(3,3,3,3,NA),
                    col=c("gray","blue","green","red","black"),
                    legend=c(sprintf("alldata (n=%d)", d1$n),
                        sprintf("background (%.1f%%)", 100*bgProp1),
                        sprintf("foreground (%.1f%%)", 100*bgProp2),
                        sprintf("P = %.3g (n_sig=%d)",pcut,
                            length(which(vals>=ratiocut)))))
            }

            cutVal <- ratiocut
        }


    }

    message(paste("Gene expression cut value:", cutVal))

    maxR <- apply(RNA, 1, function(x) max(x))
    RNA <- RNA[which(maxR>cutVal),]
    txs <- txs[ txs$gene_id %in% rownames(RNA)  ]

    if (!is.na(geneType)) {
        cols <- colnames(as.data.frame(txsSel))
        if ("gene_type" %in% cols) {
            txsSel <- txs[which(txs$gene_type==geneType),]
            if (length(txsSel) == 0) {
                stop(sprintf("The gene type \"%s\" is not found!", geneType))
            }
            geneIds <- unique(txsSel$gene_id)
            txs <- txsSel
            RNA <- RNA[  rownames(RNA) %in% geneIds , ]
        } else {
            warning("The metadata column \"gene_type\" is not present in
                gene coordinates. Skipping this step...")
        }

    }

    message(paste("Filtered result:", nrow(RNA), "genes"))
    #obj@exprs <- RNA
    #obj@geneCoords <- txs

    if (nrow(RNA)  == 0)
      warning("All genes are filtered! Check exprs() matrix for details.")


    exprsInitial <- experiments(obj@sigMAE)[["exprs"]]
    experiments(obj@sigMAE)[["exprs"]] <- exprsInitial[rownames(RNA),]

    return(obj)

}

#' Function to estimate gene expression
#'
#' This function uses mclust package to analyze gene expression distribution
#' @param x Full gene expression vector
#' @return Distribution properties: mean and std
#' @import mclust
#' @details
#' The function adjust filtering cut value based on mclust library to exclude
#' low expressed genes. It is a part of filtering procedure.
get.enr.bg.normfit <- function(x) {

    result <- c(NA, NA)

    # NOTE: no idea how not to depend on mclust
    # requireNamespace() did not work properly

    if (requireNamespace("mclust")) {
        names(result) <- c("mean","sd")

        # fit two normal distributions to data
        # model <- Mclust(na.omit(x), G=2, modelNames="V")
        model <- mclust::Mclust(na.omit(x), G=2)

        # bg corresponds to first (lower mean) normal
        result[1] <- model$parameters$mean[1]
        result[2] <- sqrt(model$parameters$variance$sigmasq[1])

        # store additional information in attributes
        attr(result, "proportions") <- model$parameters$pro
        attr(result, "enr.mean") <- as.numeric(model$parameters$mean[2])
        attr(result, "enr.sd") <- sqrt(model$parameters$variance$sigmasq[2])

        # return results
    } else {
        message("Mclust library not detected, skipping cut value adjustment...")
    }
    result
}

---
title: "Correlation of epigenetic signals and genes in TADs"
author:
- name: Konstantin Okonechnikov
  affiliation: German Cancer Research Center (DKFZ), Heidelberg, Germany
output: 
    BiocStyle::html_document
abstract: |
  The InTAD package is focused on the detection of correlation between  expressed genes and selected epigenomic signals (i.e. enhancers) either located within same topologically associated domains (TADs) or connected via chromatin loops. 
  For the first task coordinates of known publicly avialable TADs can be used due to their stability across cell types. 
  Additionally novel TADs or direct loops detected using HiC technology can be applied to strengthen the specificity.
  For the usage of TADs the analysis procedure starts from collecting signals and genes lying in the same TAD. Then the combined groups in a TAD are analyzed to detect correlations among them. 
  For the usage of HiC loops the procedure starts from searching for connections between genes and target signals. Afterwards correlation is computed in similar manner as with TADs for each signal-gene pair.
  Various parameters can be 
  further controlled. For example, the gene expression filters, correlation 
  methods (Pearson, Spearman), statistical limits (q-value computation), etc. 
  The connection to TADs can be also expanded to find correlation with closest 
  gene outside of a TAD. Multiple analysis steps include generation of special
  plots for results visualization.
vignette: |
  %\VignetteIndexEntry{Correlation of epigenetic signals and genes in TADs}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Introduction 

The InTAD analysis is focused on the processing of generated object that 
combines all input datasets. Required input data is the following:

* epigenetic signals data.frame e.g. enhancers along with their coordinates in 
GRanges format 
* gene expression counts data.frame along with gene coordinates 
in GRanges format
* TAD borders GRanges or loops data.frame e.g. from results of HiC technique application

Further explained example of performing the analysis procedure is based on 
H3K27ac data reflecting activity of enhancers in medulloblastoma brain tumour 
descrbied in the manuscript from [C.Y.Lin, S.Erkek et al., Nature, 
2016.](http://www.nature.com/nature/journal/v530/n7588/full/nature16546.html)

This dataset includes normalized enhancer signals obtained from H3K27ac 
ChIP-seq data and RNA-seq gene expression RPKM counts from 25  medulloblastoma 
samples. The test subset is extracted from a selected region inside 
chromosome 15. Additionally, the coordinates for enhancers and genes along 
with specific sample annotation are provided. 

The analysis starts from preparing and loading the data. Here is the 
overview of integrated input test data, that can serve as a useful example 
describing supported input formats:

```{r quick-start,  message=FALSE, warning=FALSE}
library(InTAD)
# normalized enhancer signals table
enhSel[1:3,1:3]
# enhancer signal genomic coordinates 
as.data.frame(enhSelGR[1:3])
# gene expression normalized counts
rpkmCountsSel[1:3,1:3]
# gene coordiantes
as.data.frame(txsSel[1:3])
# additional sample info data.frame
head(mbAnnData)
```

Importantly, there are specific requriements for the input datasets. The names 
of samples should match in signals and gene expression datasets. 
```{r input-check1,  warning=FALSE}
summary(colnames(rpkmCountsSel) == colnames(enhSel))
```
Next, the genomic regions should be provided for each signal as well as for 
each gene. 
```{r input-check2,  warning=FALSE}
# compare number of signal regions and in the input table
length(enhSelGR) == nrow(enhSel)
```
The genomic regions reflecting the gene coordinates must include *"gene_id"* 
and *"gene_name"* marks. These are typical GTF format markers. One more mark 
*"gene_type"* is also useful to perform filtering of gene expression matrix.  

All the requirements are checked during the generation of the **InTADSig** 
object. Main part of this object is `r Biocpkg("MultiAssayExperiment")` subset 
that combines signals and gene expression. Specific annotation information 
about samples can be also included for further control and visualization. In 
provided example for medulloblastoma samples annotation contains various 
aspects such as tumour subgroup, age, gender, etc.

```{r test,  warning=FALSE}
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel,mbAnnData)
```
The created object contains MultiAssayExperiment that includes both signals and 
gene expression data. 

```{r test2,  warning=FALSE}
inTadSig
```

During the main object generation there are also available special options to 
activate parallel computing based on usage of R multi-thread librares and log2 adjustment for gene expression. The generated data subsets can be 
accessed using specific call functions on the object i.e. *signals* or *exprs*. 

Notably, the main object can be also loaded from the text files representing 
the input data using function *loadSigInTAD*. Refer to the documetation of this 
function for more details.

# Main data analysis using TADs

The usage of input gene expression counts matrix assumes filtering of non- or low expressed genes. However if these counts were not filtered before starting the  InTAD analysis it's possible to adjust gene expression limits using function *filterGeneExpr*. This function provides parameters to control 
minimum gene expression and type. There is additionally a special option to 
compute gene expression distribution based on usage of `r CRANpkg("mclust")` 
package in order to find suitable minimum gene expression cut limit. 
Here's example how to use this procedure:

```{r filter-genes,  warning=FALSE}
# filter gene expression
inTadSig <- filterGeneExpr(inTadSig, checkExprDistr = TRUE)
```

The analysis starts from the combination of signals and genes inside the TADs. 
Since the TADs are known to be stable across various cell types, it's possible 
to use already known TADs obtained from IMR90 cells using HiC technology 
([Dixon et al 2012](https://www.nature.com/articles/nature11082)). The human 
IMR90 TADs regions object is integrated into the package. 
```{r tad1,  warning=FALSE}
# IMR90 hg19 TADs
head(tadGR)
```
However, since the variance is actually observed between TAD calling methods 
(i.e. described in detailed review by [Rola Dali and Mathieu Blanchette, NAR
2017](https://academic.oup.com/nar/article/45/6/2994/3059658) ), novel obtained 
TADs can be also applied for the analysis. The requried format: GRanges object. 

Composition of genes and signals in TADs is performed using function 
*combineInTAD* that has several options. By default, it marks the signal 
belonging to the TAD by largest overlap and also takes into account genes that 
are not overlaping the TADs by connecting them to the closest TAD. This can be 
sensetive strategy since some genomic regions can be missed due to the limits 
of input HiC data and variance of existing TAD calling methods. 

```{r tad2,  warning=FALSE}
# combine signals and genes in TADs
inTadSig <- combineInTAD(inTadSig, tadGR)
```

Final step is the correlation analysis. Various options are avialble for this 
function i.e. correlation method, computation of q-value to control the 
evidence strength and visualization of connection proportions. This last option 
allows to show differences in gene and signal regulations.
```{r cor,  warning=FALSE}
par(mfrow=c(1,2)) # option to combine plots in the graph
# perform correlation anlaysis
corData <- findCorrelation(inTadSig,plot.proportions = TRUE)
```

The result data.frame has a special format. It includes each signal, TAD, gene 
and correlation information.
```{r cor2,  warning=FALSE}
head(corData,5)
```
Further filtering of this result data can be performed by adjusting p-value and 
correlation effect limits (i.e. p-val < 0.01, positive correlation only). 

# Integration of chromatin loops

Another clear approach to find contacts between genes and epigenetic signals
is to use direct chromatin connections, so called loops. The loops are typically derived from HiC data and there are well-known tools that allow to perform this (e.g. [FitHiC](https://ay-lab.github.io/fithic/) or [HiCCUPS](https://github.com/aidenlab/juicer/wiki/HiCCUPS)).

![An example of chromatin loops visualisation from IGV showing connection of medulloblastoma tumor specific enhancers to genes. The loops are derived from IMR90 HiC data.](figures/loops_image.png) 

InTAD starting from version 1.9.1 also allows to use HiC loops for the analysis. Main functions to perform this task are  *combineWithLoops* and *findCorFromLoops*.

To demonstrate this approach InTAD includes an example subset of loops derived from [IMR90 cells](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525). This loops data.frame has a specific format where the first 6 columns represent genomic regions for both loop anchors:  *(chr1,start1,end1,chr2,start2,end2)*:
```{r loopsDf,  warning=FALSE}
loopsDfSel[1:4,1:6]
```
The loaded loops are applied to find connections between genes and signals using function *combineWithLoops*. By default 6-column loops format is expected, but the function also supports 4-column format where for the loop anchors only middle positions are provided (as in [FitHiC](https://ay-lab.github.io/fithic/) output): *(chr1,middlePos1,chr2,middlePos2)* . 

Howerer in this case loop fragment length is also required and using the variable *fragmentLength* allows to activate this format. In addition  other parameters (e.g. transcription start site width, extension of the loops) can be controlled to increase the sensitivity. 

In result the function reports how many connections are detected to be supported by loops and saves them within the returned InTAD object:
```{r loopsDf2,  warning=FALSE}
inTadSig <- combineWithLoops(inTadSig, loopsDfSel)
```

In this particular example only 1 connection between gene and enhancer is found. To find if there are correlations between detected connected signal-gene pairs the function *fincCorFromLoops* is applied. It has a list of options similar to corresponding function *findCorrelation* for usage of TADs (e.g. correlation method, adjusted p-value):

```{r loopsDf3,  warning=FALSE}
loopEag <- findCorFromLoops(inTadSig,method = "spearman")
```

Final result also has format similar to representation of correlations between genes and enhancers within TADs. The only difference is that the loops supporting found connection are included:

```{r loopsDf4,  warning=FALSE}
loopEag
```

In general, the focus on loops allows to increase the specificity of the detected connections between signals and genes in order to find possible perspective targets for further investigation. However, ideally it should be applied on HiC data derived from the same research target materials (e.g. same tumor type), while TADs from other sources could be used due to their stability. 

# Visualization 

The package provides post-analysis visualization function: the specific signal 
and gene can be selected for correlation plot generation. Here's example of 
verified medulllobastoma Group3-specifc enhancer assoicated gene GABRA5 lying 
in the same TAD as the enhancer, but not close to the gene:


```{r plot0, warning=FALSE}

# example enhancer in correlation with GABRA5
cID <- "chr15:26372163-26398073" 
selCorData <- corData[corData$peakid == cID, ]
selCorData[ selCorData$name == "GABRA5", ] 
```

For the plot generation it is required to provide the signal id and gene name:

```{r plot1,fig.align = "center", warning=FALSE}

plotCorrelation(inTadSig, cID, "GABRA5",
                xLabel = "RPKM gene expr log2",
                yLabel = "H3K27ac enrichment log2", 
                colByPhenotype = "Subgroup")
```

Note that in the visualization it's also possible to mark the colours 
representing the samples using option *colByPhenotype* based on the sample 
annotation information included in the generation of the main object. In the 
provided example medulloblastma tumour subgroups are marked.

Specific genomic region of interest can be also visualised to observe the 
variance and impact of TADs using special function that works on result 
data.frame obtained from function *findCorrelation*. The resulting plot 
provides the location of signals in X-axis and genes in Y-axis. Each point 
reflects the correlation stength based on p-value: *-log10(P-val)*. This 
visualization strategy was introduced in the study by [S. Waszak et al, Cell, 
2015](https://www.sciencedirect.com/science/article/pii/S0092867415009770) 
focused on investigation of chromatin architecture in human cells. 

By default only detected TADs  with signals inside are visualized, 
but it is also possible to include all avaialble TAD regions using special 
option. Here's the example plot covering the whole chromosome 15 region used
in the test dataset: 

```{r plot3, fig.align = "center", warning=FALSE}
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 tads = tadGR)
```

One more option of this function allows to activaite representation of postive
correlation values from 0 to 1 instead of strength.

```{r plot4, fig.align = "center", warning=FALSE}
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 showCorVals = TRUE, tads = tadGR)
```

It's also possible to focus on the connections by ignoring the signal/gene 
locations and focusing only on correlation values by adjusting for symmetery.
This is typical approach used for HiC contact data visualization in such 
tools as for example [JuiceBox](http://aidenlab.org/juicebox/). This can be activate by using the corresponding option:

```{r plot5, fig.align = "center", warning=FALSE}
plotCorAcrossRef(inTadSig,corData,
                 targetRegion = GRanges("chr15:25000000-28000000"), 
                 showCorVals = TRUE, symmetric = TRUE, tads = tadGR)
```

These visualization strategies allow to investigate the impact of TADs.

Additional documentation is available for each function via standard R help.

# Session info 

Here is the output of `sessionInfo()` on the system on which this
document was compiled:

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

# References

*[Dali, R. and Blanchette, M., 2017. A critical assessment of topologically 
associating domain prediction tools. Nucleic acids research, 45(6),
pp.2994-3005.](https://academic.oup.com/nar/article/45/6/2994/3059658)*

*[Dixon, J.R., Selvaraj, S., Yue, F., Kim, A., Li, Y., Shen, Y., Hu, M., 
Liu, J.S. and Ren, B., 2012. Topological domains in mammalian genomes
identified by analysis of chromatin interactions. Nature, 485(7398),
p.376.](https://www.nature.com/articles/nature11082)*

*[Lin, C.Y., Erkek, S., Tong, Y., Yin, L., Federation, A.J., Zapatka, M., 
Haldipur, P., Kawauchi, D., Risch, T., Warnatz, H.J. and Worst, B.C., 2016. 
Active medulloblastoma enhancers reveal subgroup-specific cellular origins. 
Nature, 530(7588), 
p.57.](http://www.nature.com/nature/journal/v530/n7588/full/nature16546.html)*

*[Waszak, S.M., Delaneau, O., Gschwind, A.R., Kilpinen, H., Raghav, S.K., 
Witwicki, R.M., Orioli, A., Wiederkehr, M., Panousis, N.I., Yurovsky, A. 
and Romano-Palumbo, L., 2015. Population variation and genetic control of modular chromatin architecture in humans. Cell, 
162(5)](https://www.sciencedirect.com/science/article/pii/S0092867415009770)*

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineSignalsWithLoops.R
\name{combineWithLoops}
\alias{combineWithLoops}
\title{Preparation for correlation analysis via loops}
\usage{
combineWithLoops(object, loopsInitDf, fragmentLength = 0, tssWidth = 2000,
  extSize = 0)
}
\arguments{
\item{object}{InTADSig object}

\item{loopsInitDf}{Data frame with loops. By default 6-column format
\emph{(chr1,start1,end1,chr2,start2,pos2)} is expected.}

\item{fragmentLength}{In case the input format is 4-column \emph{(chr1,middlePos1,
chr2, middlePos2)} fragment length should be provided to extend the
corresponding loci for loop start and end positions.}

\item{tssWidth}{The transcription start site width is used to control overlaps
with loop anchor. Default is 2000 base pairs.}

\item{extSize}{The loop endings can be extended upstream and downstream
with provided corresponding increase size in base pairs.}
}
\value{
Updated InTADSig object containing genes connected to signals
via loops
}
\description{
This function combines signals and genes based on the usage
of loops obtained from HiC data analysis
}
\details{
The expected input is the loops data.frame applied to find
connections of signals to genes. This data.frame could be
in two formats: either \emph{(chr1,start1,end1,chr2,start2,end2)} or
\emph{(chr1,middlePos1,chr2,middlePos2)} with fragment size.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{tadGR}
\alias{tadGR}
\title{Genomic coordiantes of topologically associated domains}
\format{a GRanges object}
\usage{
tadGR
}
\value{
NULL, but makes available the dataset
}
\description{
This GRanges object contains the coordinates of TADs
revealed from IMR90 cell line (extracted from 0-indexed .bed file)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCorrelation.R
\name{plotCorrelation}
\alias{plotCorrelation}
\title{Function to plot correlation}
\usage{
plotCorrelation(obj, sId, geneName, xLabel = "Gene expression",
  yLabel = "Signal enrichment", colByPhenotype = "",
  corMethod = "pearson")
}
\arguments{
\item{obj}{InTADSig object with signals and genes combined in TADS}

\item{sId}{Signal id based on genomic cooridantes i.e. "chr:start-end"}

\item{geneName}{Gene name to select. Based on "gene_name" attribute.}

\item{xLabel}{The label to mark signal X-axis. Default: "Gene expression"}

\item{yLabel}{The label to mark signal Y-axis. Default: "Signal enrichment"}

\item{colByPhenotype}{The pheno data column i.e. tumour type
that can be use for colour}

\item{corMethod}{Correlation method. Default: Pearson}
}
\value{
A \code{ggplot} object for visualization or customization.
}
\description{
This function creates a plot of selected pair signal-gene
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
inTadSig <- combineInTAD(inTadSig, tadGR)
plotCorrelation(inTadSig, "chr15:26372163-26398073", "GABRA5")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findCorrelation.R
\name{findCorrelation}
\alias{findCorrelation}
\title{Function to perfrom correlation analysis in TADs}
\usage{
findCorrelation(object, method = "pearson", adj.pval = FALSE,
  plot.proportions = FALSE)
}
\arguments{
\item{object}{InTADSig object with signals and genes combined in TADS}

\item{method}{Correlation method: "pearson" (default), "kendall", "spearman"}

\item{adj.pval}{Perform p-value adjsutment and include q-values in result}

\item{plot.proportions}{Plot proportions of signals and genes in correlation}
}
\value{
A table with correlation values for signal-gene pairs including
correlation p-value, euclidian distance and rank.
}
\description{
This function combines genes and signals in inside of TADs
}
\examples{
## perform analysis on test data
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding")
inTadSig <- combineInTAD(inTadSig, tadGR)
corData <- findCorrelation(inTadSig, method="pearson")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig.R
\docType{methods}
\name{geneCoords}
\alias{geneCoords}
\alias{geneCoords,InTADSig-method}
\title{Gene coords GRanges}
\usage{
geneCoords(object)

\S4method{geneCoords}{InTADSig}(object)
}
\arguments{
\item{object}{InTADSig object with signals and genes}
}
\value{
Gene GRanges
}
\description{
This funcion returns the gene GRanges
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
head(geneCoords(inTadSig))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{txsSel}
\alias{txsSel}
\title{Genomic coordiantes of genes subset}
\format{a GRanges object}
\usage{
txsSel
}
\value{
NULL, but makes avaialbe the dataset
}
\description{
This GRanges object contains the coordinates of genes
subset from chr15
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCorrelation.R
\name{plotCorAcrossRef}
\alias{plotCorAcrossRef}
\title{Function to plot correlation across genome}
\usage{
plotCorAcrossRef(obj, corRes, targetRegion, showCorVals = FALSE,
  symmetric = FALSE, tads = NULL)
}
\arguments{
\item{obj}{InTADSig object with signals and genes combined in TADS}

\item{corRes}{Correlation result table created by function findCorrelation()}

\item{targetRegion}{Target genomic region visualise.}

\item{showCorVals}{Use this option to visualize postive correlation values
instead of correlation strength}

\item{symmetric}{Activate mirrow symmetry for gene-signal connections}

\item{tads}{TAD regions to visualize. By default only TADs persent in
correlation result table are applied (NULL value).}
}
\value{
A \code{ggplot} object for visualization or customization.
}
\description{
This function creates a plot of correlation strength
in target genomic region from the result table.
The X-coordinates represent signals, Y-coords represent genes, while
each dot represents -log10(P-value) from correlation test.
Additionallly all TAD boundaries can be visualized.
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
inTadSig <- combineInTAD(inTadSig, tadGR)
corData <- findCorrelation(inTadSig, method="pearson")
plotCorAcrossRef(inTadSig,corData,GRanges("chr15:25000000-28000000"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig.R
\docType{methods}
\name{sigCoords}
\alias{sigCoords}
\alias{sigCoords,InTADSig-method}
\title{Signal coords GRanges}
\usage{
sigCoords(object)

\S4method{sigCoords}{InTADSig}(object)
}
\arguments{
\item{object}{InTADSig object with signals and genes}
}
\value{
Signal GRanges
}
\description{
This funcion returns the signal GRanges
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
head(sigCoords(inTadSig))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig.R
\docType{methods}
\name{exprs,InTADSig-method}
\alias{exprs,InTADSig-method}
\title{Gene expression counts table}
\usage{
\S4method{exprs}{InTADSig}(object)
}
\arguments{
\item{object}{InTADSig object with signals and genes}
}
\value{
Gene expression table
}
\description{
This funcion returns gene expression counts table
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
head(exprs(inTadSig))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineSignalsInTAD.R
\name{fnSE}
\alias{fnSE}
\title{Preparation for correlation analysis for a signal}
\usage{
fnSE(id, sigList, tadGR, tss, pickMaxOvlp, nearestTad)
}
\arguments{
\item{id}{Id of signal from the list}

\item{sigList}{List of signal GRs and their names}

\item{tadGR}{TAD genomic regions}

\item{tss}{Gene transcription start sites}

\item{pickMaxOvlp}{Use TAD with max overlap}

\item{nearestTad}{The table listing TADs nearest to each TSS
#'}
}
\value{
Data.frame containing genes connected to signal
}
\description{
This function collects all genes for signal genomic region inside of
Topologically Associated Domains (TADs)
}
\details{
The signal is checked if it is lying inside of TAD.
Then all genes in this TAD are collected.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig-methods.R
\name{loadSigInTAD}
\alias{loadSigInTAD}
\title{Load InTADSig object from text files}
\usage{
loadSigInTAD(signalsFile, countsFile, gtfFile, annFile = "",
  performLog = TRUE, logExprsOffset = 1, ncores = 1)
}
\arguments{
\item{signalsFile}{Tab-seprated data table containg signals and their
coordinates as row.names}

\item{countsFile}{Tab-seprated counts table}

\item{gtfFile}{GTF file containing all gene coordinates}

\item{annFile}{Tab-delimited phenotype annotation of samples}

\item{performLog}{Perform log2 convertion of expression values.
Default: TRUE.}

\item{logExprsOffset}{Offset x for log2 gene exrpression
i.e. log2(value + x). Default: 1}

\item{ncores}{Number of cores to use for parallel computing}
}
\value{
Novel InTADSig object
}
\description{
The fuction loads the data tables to create an object that contains the
signals and gene expression data.frames along with their genomic coordinates
for further processing.
}
\details{
The function loads data from input files and creates object that stores
matrices of signals and gene expression values along with coordiantes.
The samples order and names of columns should match in both tables.
It is expected that gene ids are applied in the validation of counts table.
}
\examples{
# create sigInTAD object
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterGeneExpr.R
\name{filterGeneExpr}
\alias{filterGeneExpr}
\title{Function to filter gene expression}
\usage{
filterGeneExpr(obj, cutVal = 0, geneType = NA, checkExprDistr = FALSE,
  plotExprDistr = FALSE)
}
\arguments{
\item{obj}{InTADSig object}

\item{cutVal}{Exclude genes that have max expression less or equal to
this value in all samples. Default: 0}

\item{geneType}{Type of gene to select for filtering i.e. "protein_coding".
Default:NA}

\item{checkExprDistr}{Adjust cutVal based on gene expression distribution}

\item{plotExprDistr}{Perform visualziation of the distribution}
}
\value{
InTADSig object with filtered counts table
}
\description{
This function performs filtering of gene expression counts based on various
 parameters
}
\details{
The function allows to stabilize the functional activity of the genes. By
default all not expressed genes are filtered. It is also possible to set type
of gene to take into account i.e. "protein_coding" only. This option requires
additional metadata column "transcript_type".
Also, special filtering option based on mclust library allows to analyze
distribution of counts and adjust the cut value to exclude low expressed
genes.
}
\examples{
## perform analysis on test data
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
## default filtering
inTadSig <- filterGeneExpr(inTadSig)
## filter based on gene type
inTadSig <- filterGeneExpr(inTadSig, geneType = "protein_coding")


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{rpkmCountsSel}
\alias{rpkmCountsSel}
\title{Gene expression subset from medulloblastoma samples}
\format{a data.frame instance}
\usage{
rpkmCountsSel
}
\value{
NULL, but makes available the dataframe
}
\description{
This data.frame contains RPKM gene expression values from chr15
for subset from 25 medulluoblastoma samples.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig.R
\docType{class}
\name{InTADSig}
\alias{InTADSig}
\alias{InTADSig-class}
\title{The InTADSig Class}
\description{
The InTADSig object stores signals and gene expression data for the samples.
}
\details{
It uses MultiAssayExperiment object to store information. Key slots to access
are listed below.
}
\section{Slots}{

   \describe{
       \item{\code{sigMAE}:}{\code{"MultiAssayExperiment"},
       MultiAssayExperiment object containg signals and gene counts }
       \item{\code{signalConnections}:}{\code{"list"},
       The list of signals representing gene data frames in the same TAD }
       \item{\code{loopsDf}:}{\code{"data.frame"},
       The data.frame containing details of provided input loops }
       \item{\code{loopConnections}:}{\code{"list"},
       The list of connections between signals and genes via loops }
       \item{\code{ncore}:}{\code{"numeric"},
       Number of cores to use for parallel computing }#'
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{loopsDfSel}
\alias{loopsDfSel}
\title{Data frame containing coordinates of loops}
\format{a data.frame object}
\usage{
loopsDfSel
}
\value{
NULL, but makes available the dataset
}
\description{
The table contains genomic coordinates of chromatin loops
in 6-column format derived from IMR90 cell line (focus : chr15)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{enhSel}
\alias{enhSel}
\title{Enhancer signals subset detected from medulloblatoma samples}
\format{a data.frame instance}
\usage{
enhSel
}
\value{
NULL, but makes available the dataframe
}
\description{
This data.frame contains 65 selected in chr15  normalized
enhancers signals subset from 25 medulloblastoma samples.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineSignalsWithLoops.R
\name{findCorFromLoops}
\alias{findCorFromLoops}
\title{Function to perfrom correlation analysis via loops.}
\usage{
findCorFromLoops(object, method = "pearson", adj.pval = FALSE)
}
\arguments{
\item{object}{InTADSig object with signals and genes combined via loops}

\item{method}{Correlation method: "pearson" (default), "kendall", "spearman"}

\item{adj.pval}{Perform p-value adjsutment and include q-values in result}
}
\value{
A table with correlation values for signal-gene pairs including
correlation p-value and euclidian distance.
}
\description{
This function combines genes and signals using obtained loop connections.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combineSignalsInTAD.R
\name{combineInTAD}
\alias{combineInTAD}
\title{Preparation for correlation analysis}
\usage{
combineInTAD(object, tadGR, selMaxTadOvlp = TRUE, closestGene = TRUE)
}
\arguments{
\item{object}{InTADSig object}

\item{tadGR}{TAD genomic regions}

\item{selMaxTadOvlp}{If a signal overlaps 2 or more TADs by default only
single TAD with max overlap is selected.All overlaps can be included by
deactivating this option.}

\item{closestGene}{By default closest to TAD genes are selected based
on TSS location. Deactivate this option to use genes only lying within TAD.}
}
\value{
Updated InTADSig object containing genes connected to eash signal
}
\description{
This function combines signals and genes in inside of
Topologically Associated Domains (TADs)
}
\details{
Each signal is checked if it is lying inside of TAD. Signals out of TADs
are ignored. The genomic regions reprenting gene coordiantes are converted
to TSS. By default, the closest genes are assigned belonging to TAD.
If this option deactivated, only those lying with TAD are collected.
Result is a list of signals connected to tables with gene details.
}
\examples{
# create sigInTAD object
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
# combine signals and genes in TAD
inTadSig <- combineInTAD(inTadSig, tadGR)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig.R
\docType{methods}
\name{signals}
\alias{signals}
\alias{signals,InTADSig-method}
\title{Signal values table}
\usage{
signals(object)

\S4method{signals}{InTADSig}(object)
}
\arguments{
\item{object}{InTADSig object with signals and genes}
}
\value{
Signals table
}
\description{
This funcion returns the signal values table
}
\examples{
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)
head(signals(inTadSig))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterGeneExpr.R
\name{get.enr.bg.normfit}
\alias{get.enr.bg.normfit}
\title{Function to estimate gene expression}
\usage{
get.enr.bg.normfit(x)
}
\arguments{
\item{x}{Full gene expression vector}
}
\value{
Distribution properties: mean and std
}
\description{
This function uses mclust package to analyze gene expression distribution
}
\details{
The function adjust filtering cut value based on mclust library to exclude
low expressed genes. It is a part of filtering procedure.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{mbAnnData}
\alias{mbAnnData}
\title{Data frame containing information about samples}
\format{a data.frame object}
\usage{
mbAnnData
}
\value{
NULL, but makes available the dataset
}
\description{
The table includes additional informaiton about MB tumour
samples (subgroup, gender, age, histology and M.Stage)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_data_info.R
\docType{data}
\name{enhSelGR}
\alias{enhSelGR}
\title{Genomic coordiantes of enhancer signals subet}
\format{a GRanges object}
\usage{
enhSelGR
}
\value{
NULL, but makes available the dataset
}
\description{
This GRanges object contains the coordinates of 65
medulloblastoma enhancer signals in chr15 target region
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InTADSig-methods.R
\name{newSigInTAD}
\alias{newSigInTAD}
\title{Create InTADSig object}
\usage{
newSigInTAD(signalData = NULL, signalRegions = NULL, countsData = NULL,
  geneRegions = NULL, sampleInfo = NULL, performLog = TRUE,
  logExprsOffset = 1, ncores = 1)
}
\arguments{
\item{signalData}{data frame containing signals}

\item{signalRegions}{genomic regions of the signals}

\item{countsData}{data matrix containing count expression values}

\item{geneRegions}{gene coordiantes}

\item{sampleInfo}{data frame containing additional sample info}

\item{performLog}{Perform log2 convertion of expression values.
Default: TRUE.}

\item{logExprsOffset}{Offset x for log2 gene exrpression
i.e. log2(value + x). Default: 1}

\item{ncores}{Number of cores to use for parallel computing}
}
\value{
Novel InTADSig object
}
\description{
The fuction generates an object that contains the signals and gene expression
data.frames along with their genomic coordinates for further processing.
}
\details{
InTADSig object stores matrices of signals and gene expression values along
with coordinates. The order of samples and names of columns should match in both
datasets. For gene coordinates GRanges "gene_id" and "gene_name" are required
in metadata. These are typical markers of genes in GTF anntotation format.
}
\examples{
## create sigInTAD object
inTadSig <- newSigInTAD(enhSel, enhSelGR, rpkmCountsSel, txsSel)


}
